diff --git a/src/bin/pg_waldump/pgupgradedesc.c b/src/bin/pg_waldump/pgupgradedesc.c
new file mode 120000
index 0000000000..c729dc19b0
--- /dev/null
+++ b/src/bin/pg_waldump/pgupgradedesc.c
@@ -0,0 +1 @@
+../../../src/backend/access/rmgrdesc/pgupgradedesc.c
\ No newline at end of file
diff --git a/src/bin/pg_waldump/rmgrdesc.c b/src/bin/pg_waldump/rmgrdesc.c
index 931ab8b979..326334e136 100644
--- a/src/bin/pg_waldump/rmgrdesc.c
+++ b/src/bin/pg_waldump/rmgrdesc.c
@@ -28,6 +28,7 @@
 #include "commands/tablespace.h"
 #include "replication/message.h"
 #include "replication/origin.h"
+#include "access/pgupgrade_wal.h"	/* pg_upgrade_desc, pg_upgrade_identify */
 #include "rmgrdesc.h"
 #include "storage/standbydefs.h"
 #include "utils/relmapper.h"
diff --git a/src/bin/pg_waldump/t/001_basic.pl b/src/bin/pg_waldump/t/001_basic.pl
index 53b2f016b8..837bdf3d14 100644
--- a/src/bin/pg_waldump/t/001_basic.pl
+++ b/src/bin/pg_waldump/t/001_basic.pl
@@ -80,7 +80,8 @@ CommitTs
 ReplicationOrigin
 Generic
 LogicalMessage
-XLOG2$/,
+XLOG2
+PgUpgrade$/,
 	'rmgr list');
 
 
diff --git a/src/common/file_utils.c b/src/common/file_utils.c
index 390e60bd01..6c897266fe 100644
--- a/src/common/file_utils.c
+++ b/src/common/file_utils.c
@@ -23,7 +23,15 @@
 #include <fcntl.h>
 #include <sys/stat.h>
 #include <unistd.h>
+#ifdef HAVE_COPYFILE_H
+#include <copyfile.h>
+#endif
+#ifdef __linux__
+#include <sys/ioctl.h>
+#include <linux/fs.h>
+#endif
 
+#include "common/file_perm.h"
 #include "common/file_utils.h"
 #ifdef FRONTEND
 #include "common/logging.h"
@@ -748,3 +756,119 @@ pg_pwrite_zeros(int fd, size_t size, pgoff_t offset)
 
 	return total_written;
 }
+
+/*
+ * pg_clone_file -- create "dst" as a reflink (copy-on-write) clone of "src".
+ *
+ * Uses copyfile(COPYFILE_CLONE_FORCE) where available (macOS), else
+ * ioctl(FICLONE) (Linux).  "dst" must not already exist.  Returns
+ * PG_REFLINK_UNSUPPORTED when the build has neither primitive,
+ * PG_REFLINK_ERROR (with *save_errno set) on a syscall failure -- in which case
+ * a partially created "dst" has been unlinked -- and PG_REFLINK_OK on success.
+ *
+ * Shared by pg_upgrade's file transfer and the backend --wal-upgrade relink
+ * replay so the two reproduce identical on-disk results.
+ */
+PGReflinkResult
+pg_clone_file(const char *src, const char *dst, int *save_errno)
+{
+	*save_errno = 0;
+
+#if defined(HAVE_COPYFILE) && defined(COPYFILE_CLONE_FORCE)
+	if (copyfile(src, dst, NULL, COPYFILE_CLONE_FORCE) < 0)
+	{
+		*save_errno = errno;
+		return PG_REFLINK_ERROR;
+	}
+	return PG_REFLINK_OK;
+#elif defined(__linux__) && defined(FICLONE)
+	{
+		int			src_fd;
+		int			dst_fd;
+
+		if ((src_fd = open(src, O_RDONLY | PG_BINARY, 0)) < 0)
+		{
+			*save_errno = errno;
+			return PG_REFLINK_ERROR;
+		}
+		if ((dst_fd = open(dst, O_RDWR | O_CREAT | O_EXCL | PG_BINARY,
+						   pg_file_create_mode)) < 0)
+		{
+			*save_errno = errno;
+			close(src_fd);
+			return PG_REFLINK_ERROR;
+		}
+		if (ioctl(dst_fd, FICLONE, src_fd) < 0)
+		{
+			*save_errno = errno;
+			close(dst_fd);
+			close(src_fd);
+			unlink(dst);
+			return PG_REFLINK_ERROR;
+		}
+		close(dst_fd);
+		close(src_fd);
+		return PG_REFLINK_OK;
+	}
+#else
+	return PG_REFLINK_UNSUPPORTED;
+#endif
+}
+
+/*
+ * pg_copy_file_range_all -- copy the whole of "src" to a new file "dst" using
+ * copy_file_range(2) (a server-side / reflink-capable copy on supporting
+ * filesystems).  "dst" must not already exist.  Return codes match
+ * pg_clone_file().
+ *
+ * Shared by pg_upgrade's file transfer and the backend --wal-upgrade relink
+ * replay.
+ */
+PGReflinkResult
+pg_copy_file_range_all(const char *src, const char *dst, int *save_errno)
+{
+	*save_errno = 0;
+
+#if defined(HAVE_COPY_FILE_RANGE)
+	{
+		int			src_fd;
+		int			dst_fd;
+
+		if ((src_fd = open(src, O_RDONLY | PG_BINARY, 0)) < 0)
+		{
+			*save_errno = errno;
+			return PG_REFLINK_ERROR;
+		}
+		if ((dst_fd = open(dst, O_RDWR | O_CREAT | O_EXCL | PG_BINARY,
+						   pg_file_create_mode)) < 0)
+		{
+			*save_errno = errno;
+			close(src_fd);
+			return PG_REFLINK_ERROR;
+		}
+
+		/* Loop until copy_file_range() reports end-of-file (a 0 return). */
+		for (;;)
+		{
+			ssize_t		nbytes = copy_file_range(src_fd, NULL, dst_fd, NULL,
+												 SSIZE_MAX, 0);
+
+			if (nbytes < 0)
+			{
+				*save_errno = errno;
+				close(dst_fd);
+				close(src_fd);
+				unlink(dst);
+				return PG_REFLINK_ERROR;
+			}
+			if (nbytes == 0)
+				break;
+		}
+		close(dst_fd);
+		close(src_fd);
+		return PG_REFLINK_OK;
+	}
+#else
+	return PG_REFLINK_UNSUPPORTED;
+#endif
+}
diff --git a/src/include/access/clog.h b/src/include/access/clog.h
index 7894998c76..2d06436ea5 100644
--- a/src/include/access/clog.h
+++ b/src/include/access/clog.h
@@ -57,4 +57,7 @@ extern void clog_redo(XLogReaderState *record);
 extern void clog_desc(StringInfo buf, XLogReaderState *record);
 extern const char *clog_identify(uint8 info);
 
+/* restore captured CLOG segment during --wal-upgrade replay */
+extern void CLOGUpgradeRestoreSegment(int64 segno, const char *data, Size datalen);
+
 #endif							/* CLOG_H */
diff --git a/src/include/access/multixact.h b/src/include/access/multixact.h
index 6be5299ab6..53f4dfd535 100644
--- a/src/include/access/multixact.h
+++ b/src/include/access/multixact.h
@@ -152,6 +152,10 @@ extern void multixact_twophase_postabort(FullTransactionId fxid, uint16 info,
 extern void multixact_redo(XLogReaderState *record);
 extern void multixact_desc(StringInfo buf, XLogReaderState *record);
 extern const char *multixact_identify(uint8 info);
+
+/* restore captured multixact SLRU segments during --wal-upgrade replay */
+extern void MultiXactOffsetUpgradeRestoreSegment(int64 segno, const char *data, Size datalen);
+extern void MultiXactMemberUpgradeRestoreSegment(int64 segno, const char *data, Size datalen);
 extern char *mxid_to_string(MultiXactId multi, int nmembers,
 							MultiXactMember *members);
 extern char *mxstatus_to_string(MultiXactStatus status);
diff --git a/src/include/access/pgupgrade_wal.h b/src/include/access/pgupgrade_wal.h
new file mode 100644
index 0000000000..03e3c61634
--- /dev/null
+++ b/src/include/access/pgupgrade_wal.h
@@ -0,0 +1,98 @@
+/*
+ * pgupgrade_wal.h
+ *
+ * declarations for RM_PG_UPGRADE_ID WAL redo and emit functions.
+ *
+ * Portions Copyright (c) 1996-2026, PostgreSQL Global Development Group
+ * Portions Copyright (c) 1994, Regents of the University of California
+ *
+ * src/include/access/pgupgrade_wal.h
+ */
+#ifndef PGUPGRADE_WAL_H
+#define PGUPGRADE_WAL_H
+
+#include "access/xlogreader.h"
+#include "catalog/pg_control.h"
+#include "lib/stringinfo.h"
+
+/* WAL upgrade check -- called from StartupProcessMain() before StartupXLOG() */
+extern bool PerformWalUpgradeIfNeeded(void);
+
+/*
+ * True iff the pg_upgrade.signal sentinel is present, i.e. this data directory
+ * is staged for --wal-upgrade recovery.  Shared gate for the detection sites in
+ * PerformWalUpgradeIfNeeded() and checkDataDir().
+ */
+extern bool UpgradeSignalStaged(void);
+
+/*
+ * Scan a pg_wal directory for the --wal-upgrade markers (START/COMPLETE)
+ * and the end-of-upgrade checkpoint (CN) that precedes START.  Used by the
+ * local/primary and archive-PITR startup paths (PerformWalUpgradeIfNeeded).
+ * Returns false if there is no readable WAL at all.
+ */
+extern bool UpgradeWalScanMarkers(const char *waldir, bool *found_start,
+								  bool *found_complete, CheckPoint *cn,
+								  XLogRecPtr *cn_lsn, uint64 *wal_sysid);
+
+/* RM_PG_UPGRADE_ID rmgr callbacks (registered in rmgrlist.h) */
+extern void pg_upgrade_redo(XLogReaderState *record);
+extern void pg_upgrade_desc(StringInfo buf, XLogReaderState *record);
+extern const char *pg_upgrade_identify(uint8 info);
+
+/* Emit functions (internal to the WAL-window capture, defined in xlog.c) */
+extern XLogRecPtr XLogWritePgUpgrade(bool is_start, uint32 old_major_version,
+									 uint32 new_major_version);
+extern XLogRecPtr XLogWritePgUpgradeHandoff(uint32 old_major_version,
+											uint32 target_major_version);
+extern XLogRecPtr XLogWriteUpgradeSlruData(uint8 slru_type);
+extern XLogRecPtr XLogWriteUpgradeRawFile(const char *path);
+extern XLogRecPtr XLogWriteUpgradeDirSkel(void);
+
+/*
+ * Emit the entire --wal-upgrade window in one C routine.  Reachable only via
+ * the binary-upgrade-gated SQL function binary_upgrade_emit_wal_window(); the
+ * individual steps are not exposed as SQL.
+ */
+extern void EmitUpgradeWalWindow(uint32 old_major_version,
+								 uint32 new_major_version,
+								 uint8 transfer_mode, bool skip_complete);
+
+/*
+ * Batched emission of relation-file images.  Many file chunks are packed into
+ * each XLOG_UPGRADE_RELFILE_DATA record, up to the max WAL payload.
+ */
+typedef struct UpgradeRelfileBatch
+{
+	char	   *buf;			/* accumulation buffer (freed by BatchEnd) */
+	Size		cap;			/* capacity == payload cap */
+	Size		used;			/* bytes accumulated for the current record */
+	int			nentries;		/* entries in the current record */
+	int			nrecords;		/* records flushed so far */
+	int			nfiles;			/* files added so far */
+	uint8		xfer_mode;		/* relink batch only: pg_upgrade transfer mode
+								 * stamped into each entry */
+} UpgradeRelfileBatch;
+
+extern void XLogUpgradeRelfileBatchBegin(UpgradeRelfileBatch *b);
+extern void XLogUpgradeRelfileBatchAddFile(UpgradeRelfileBatch *b, const char *path,
+										   Oid tsoid, Oid dboid, RelFileNumber rfnum,
+										   uint8 forknum, uint32 segno);
+extern void XLogUpgradeRelfileBatchEnd(UpgradeRelfileBatch *b);
+
+/*
+ * Batched emission of the XLOG_UPGRADE_RELINK manifest: one fixed-size entry
+ * per USER relation file that pg_upgrade transferred verbatim (and the window
+ * therefore omits).  No file data, just identities; redo links them from the
+ * standby's old datadir.  Reuses UpgradeRelfileBatch for the accumulation state.
+ */
+extern void XLogUpgradeRelinkBatchBegin(UpgradeRelfileBatch *b, uint8 xfer_mode);
+extern void XLogUpgradeRelinkBatchAdd(UpgradeRelfileBatch *b,
+									  Oid tsoid, Oid dboid, RelFileNumber rfnum,
+									  uint8 forknum, uint32 segno);
+extern void XLogUpgradeRelinkBatchEnd(UpgradeRelfileBatch *b);
+
+/* force-flush SLRU dirty pages bypassing enableFsync -- for pg_upgrade with fsync=off */
+extern void XLogFlushUpgradeSLRU(void);
+
+#endif							/* PGUPGRADE_WAL_H */
diff --git a/src/include/access/rmgrlist.h b/src/include/access/rmgrlist.h
index ae32ef16d6..b3ec186a88 100644
--- a/src/include/access/rmgrlist.h
+++ b/src/include/access/rmgrlist.h
@@ -48,3 +48,5 @@ PG_RMGR(RM_REPLORIGIN_ID, "ReplicationOrigin", replorigin_redo, replorigin_desc,
 PG_RMGR(RM_GENERIC_ID, "Generic", generic_redo, generic_desc, generic_identify, NULL, NULL, generic_mask, NULL)
 PG_RMGR(RM_LOGICALMSG_ID, "LogicalMessage", logicalmsg_redo, logicalmsg_desc, logicalmsg_identify, NULL, NULL, NULL, logicalmsg_decode)
 PG_RMGR(RM_XLOG2_ID, "XLOG2", xlog2_redo, xlog2_desc, xlog2_identify, NULL, NULL, NULL, xlog2_decode)
+/* dedicated resource manager for all pg_upgrade WAL records */
+PG_RMGR(RM_PG_UPGRADE_ID, "PgUpgrade", pg_upgrade_redo, pg_upgrade_desc, pg_upgrade_identify, NULL, NULL, NULL, NULL)
diff --git a/src/include/access/slru.h b/src/include/access/slru.h
index b4adb1789c..4d4af5e8d1 100644
--- a/src/include/access/slru.h
+++ b/src/include/access/slru.h
@@ -227,6 +227,10 @@ extern int	SimpleLruReadPage_ReadOnly(SlruDesc *ctl, int64 pageno,
 									   const void *opaque_data);
 extern void SimpleLruWritePage(SlruDesc *ctl, int slotno);
 extern void SimpleLruWriteAll(SlruDesc *ctl, bool allow_redirtied);
+
+/* restore a captured SLRU segment image during --wal-upgrade replay */
+extern void SlruUpgradeRestoreSegment(SlruDesc *ctl, int64 segno,
+									  const char *data, Size datalen);
 #ifdef USE_ASSERT_CHECKING
 extern void SlruPagePrecedesUnitTests(SlruDesc *ctl, int per_page);
 #else
diff --git a/src/include/access/xlog.h b/src/include/access/xlog.h
index 4dd9862420..d2a1bc1b8e 100644
--- a/src/include/access/xlog.h
+++ b/src/include/access/xlog.h
@@ -98,6 +98,26 @@ typedef enum RecoveryState
 extern PGDLLIMPORT int wal_level;
 extern PGDLLIMPORT bool XLogLogicalInfo;
 
+/*
+ * pg_upgrade --wal-upgrade streaming-standby transfer mode (postgresql.conf
+ * GUC pg_upgrade_standby_transfer_mode).  PG_UPGRADE_XFER_MIRROR reproduces the
+ * per-file mode the primary recorded in the manifest; the others override it.
+ * Concrete modes map to UPGRADE_RELINK_MODE_* in pg_control.h.  See
+ * ArmFromLocalDerivationIfConfigured().
+ */
+typedef enum
+{
+	PG_UPGRADE_XFER_MIRROR = -1,	/* unset: use the manifest's per-file mode */
+	PG_UPGRADE_XFER_CLONE = 0,
+	PG_UPGRADE_XFER_COPY = 1,
+	PG_UPGRADE_XFER_COPY_FILE_RANGE = 2,
+	PG_UPGRADE_XFER_LINK = 3,
+	PG_UPGRADE_XFER_SWAP = 4,
+} PgUpgradeTransferMode;
+
+extern PGDLLIMPORT int pg_upgrade_standby_transfer_mode;
+extern PGDLLIMPORT char *pg_upgrade_standby_old_datadir;
+
 /* Is WAL archiving enabled (always or only while server is running normally)? */
 #define XLogArchivingActive() \
 	(AssertMacro(XLogArchiveMode == ARCHIVE_MODE_OFF || wal_level >= WAL_LEVEL_REPLICA), XLogArchiveMode > ARCHIVE_MODE_OFF)
@@ -273,6 +293,47 @@ extern WALAvailability GetWALAvailability(XLogRecPtr targetLSN);
 extern void XLogPutNextOid(Oid nextOid);
 extern XLogRecPtr XLogRestorePoint(const char *rpName);
 extern XLogRecPtr XLogAssignLSN(void);
+
+/* pg_upgrade WAL markers */
+extern XLogRecPtr XLogWritePgUpgrade(bool is_start,
+									 uint32 old_major_version,
+									 uint32 new_major_version);
+
+/* SLRU bulk image for pg_upgrade WAL replay */
+extern XLogRecPtr XLogWriteUpgradeSlruData(uint8 slru_type);
+
+/* arm pg_control at CN for in-process --wal-upgrade recovery */
+struct CheckPoint;
+extern void ArmControlFileForUpgradeRecovery(const struct CheckPoint *cn,
+											 XLogRecPtr cn_lsn,
+											 uint64 wal_sysid,
+											 bool for_streaming);
+
+/* control-file checkpoint LSN, for the "upgrade already applied?" test */
+extern XLogRecPtr GetControlFileCheckPointLSN(void);
+
+/*
+ * informational DB_IN_UPGRADE flips during window replay (set at START,
+ * cleared back to DB_IN_PRODUCTION at COMPLETE) -- diagnostics only
+ */
+extern void SetControlFileInUpgrade(void);
+extern void ClearControlFileInUpgrade(void);
+extern void SynthesizeUpgradeStreamControlFile(bool allow_overwrite);
+
+/*
+ * --wal-upgrade: durable "window replayed to COMPLETE" flag in pg_control
+ * (replaces the former pg_upgrade_complete.done marker file).  Set at COMPLETE
+ * redo; paired with a control checkpoint past CN to decide "finalized".
+ */
+extern void SetControlFileUpgradeFinalized(void);
+extern bool GetControlFileUpgradeFinalized(void);
+extern void SetControlFileUpgradeStarted(void);
+extern bool GetControlFileUpgradeStarted(void);
+
+/* emit the streaming-handoff trigger at shutdown if pg_upgrade armed it */
+extern void EmitPgUpgradeHandoffIfArmed(void);
+
+/* batched relation-file images live in access/pgupgrade_wal.h */
 extern void UpdateFullPageWrites(void);
 extern void GetFullPageWriteInfo(XLogRecPtr *RedoRecPtr_p, bool *doPageWrites_p);
 extern XLogRecPtr GetRedoRecPtr(void);
@@ -333,6 +394,19 @@ extern SessionBackupState get_backup_status(void);
 #define RECOVERY_SIGNAL_FILE	"recovery.signal"
 #define STANDBY_SIGNAL_FILE		"standby.signal"
 #define BACKUP_LABEL_FILE		"backup_label"
+/* armed by pg_upgrade --wal-upgrade-signal-handoff; consumed by ShutdownXLOG */
+#define PG_UPGRADE_HANDOFF_SIGNAL_FILE	"pg_upgrade_handoff.pending"
+/*
+ * Empty, presence-only sentinel (like standby.signal) the operator stages into
+ * a --wal-upgrade recovery target; its presence arms upgrade replay at
+ * first-startup.  Recovery mode comes from stock config (primary_conninfo =>
+ * stream from the live primary; recovery.signal => restore_command).  The
+ * standby-local options (old-datadir path, transfer mode) live in
+ * postgresql.conf GUCs, not in this file.  See
+ * ArmFromLocalDerivationIfConfigured().
+ */
+#define PG_UPGRADE_SIGNAL_FILE			"pg_upgrade.signal"
+
 #define BACKUP_LABEL_OLD		"backup_label.old"
 
 #define TABLESPACE_MAP			"tablespace_map"
diff --git a/src/include/access/xlogrecovery.h b/src/include/access/xlogrecovery.h
index ba7750dca0..961350e156 100644
--- a/src/include/access/xlogrecovery.h
+++ b/src/include/access/xlogrecovery.h
@@ -150,6 +150,13 @@ extern PGDLLIMPORT TimeLineID recoveryTargetTLI;
 /* Have we already reached a consistent database state? */
 extern PGDLLIMPORT bool reachedConsistency;
 
+/*
+ * Set while replaying a pg_upgrade --wal-upgrade window (between
+ * XLOG_UPGRADE_START and XLOG_UPGRADE_COMPLETE).  Suppresses hot standby
+ * activation so no read-only connection sees a half-upgraded cluster.
+ */
+extern PGDLLIMPORT bool pgUpgradeReplayInProgress;
+
 /* Are we currently in standby mode? */
 extern PGDLLIMPORT bool StandbyMode;
 
diff --git a/src/include/catalog/catversion.h b/src/include/catalog/catversion.h
index 73ed6a0fa4..3abfa1ef36 100644
--- a/src/include/catalog/catversion.h
+++ b/src/include/catalog/catversion.h
@@ -57,6 +57,6 @@
  */
 
 /*							yyyymmddN */
-#define CATALOG_VERSION_NO	202607022
+#define CATALOG_VERSION_NO	202607023
 
 #endif
diff --git a/src/include/catalog/pg_control.h b/src/include/catalog/pg_control.h
index 80b3a730e0..e52ecf7359 100644
--- a/src/include/catalog/pg_control.h
+++ b/src/include/catalog/pg_control.h
@@ -17,12 +17,13 @@
 
 #include "access/transam.h"
 #include "access/xlogdefs.h"
+#include "common/relpath.h"		/* for RelFileNumber */
 #include "pgtime.h"				/* for pg_time_t */
 #include "port/pg_crc32c.h"
 
 
 /* Version identifier for this pg_control format */
-#define PG_CONTROL_VERSION	1902
+#define PG_CONTROL_VERSION	1905
 
 /* Nonce key length, see below */
 #define MOCK_AUTH_NONCE_LEN		32
@@ -83,12 +84,198 @@ typedef struct CheckPoint
 #define XLOG_FPI						0xB0
 #define XLOG_ASSIGN_LSN					0xC0
 #define XLOG_OVERWRITE_CONTRECORD		0xD0
+
+/*
+ * pg_upgrade WAL record types in RM_PG_UPGRADE_ID.
+ * Using a dedicated rmgr gives us a clean 0x10-aligned namespace free from
+ * the XLR_RMGR_INFO_MASK = 0xF0 constraint that limits RM_XLOG_ID to one
+ * record type per 0x10 bucket.
+ */
+#define XLOG_UPGRADE_START			0x00	/* upgrade window start marker */
+#define XLOG_UPGRADE_COMPLETE		0x10	/* upgrade window complete marker */
+#define XLOG_UPGRADE_SLRU_DATA			0x20	/* bulk SLRU segment image */
+#define XLOG_UPGRADE_RELFILE_DATA		0x30	/* bulk relation file segment
+												 * image */
+#define XLOG_UPGRADE_RAWFILE			0x50	/* verbatim non-relation file
+												 * image (pg_filenode.map,
+												 * PG_VERSION) */
+#define XLOG_UPGRADE_DIRTREE			0x40	/* logged after-image of the
+												 * initdb directory tree */
+#define XLOG_UPGRADE_HANDOFF			0x60	/* OLD-format
+												 * streaming-handoff trigger,
+												 * emitted in the OLD
+												 * cluster's own WAL just
+												 * before pg_upgrade shuts it
+												 * down */
+#define XLOG_UPGRADE_RELINK				0x70	/* manifest of user relations
+												 * to link from the standby's
+												 * old datadir (not carried in
+												 * the window) */
 #define XLOG_CHECKPOINT_REDO			0xE0
 #define XLOG_LOGICAL_DECODING_STATUS_CHANGE	0xF0
 
 /* XLOG info values for XLOG2 rmgr */
 #define XLOG2_CHECKSUMS					0x00
 
+/*
+ * XLOG_UPGRADE_START / XLOG_UPGRADE_COMPLETE -- mark the upgrade window so
+ * crash recovery and tooling (pg_waldump) can identify it and verify
+ * atomicity.  pg_version[] carries $PGDATA/PG_VERSION, which initdb writes
+ * outside the server and is not otherwise WAL-logged.  See pg_upgrade_redo().
+ */
+typedef struct xl_pg_upgrade
+{
+	uint32		old_major_version;	/* old cluster PG_VERSION_NUM major */
+	uint32		new_major_version;	/* new cluster PG_VERSION_NUM major */
+	pg_time_t	upgrade_time;	/* wall-clock time of this record */
+	char		pg_version[8];	/* new cluster PG_MAJORVERSION, e.g. "18\n" */
+} xl_pg_upgrade;
+
+#define SizeOfXLPgUpgrade	sizeof(xl_pg_upgrade)
+
+/*
+ * XLOG_UPGRADE_HANDOFF -- streaming-standby handoff trigger.  Carries no data;
+ * it is a control signal.  Unlike the other pg_upgrade records (new-format WAL
+ * readable only by the new binary), this is emitted into the old cluster's own
+ * WAL in the old format just before shutdown, so a physical standby still
+ * streaming the old primary can read it.  On replay a StandbyMode server stops
+ * cleanly at this LSN and reports that a handoff is beginning.
+ * target_major_version is informational (log message only).
+ * See pg_upgrade_redo().
+ */
+typedef struct xl_pg_upgrade_handoff
+{
+	uint32		old_major_version;	/* this (old) cluster's major version */
+	uint32		target_major_version;	/* major version being upgraded to */
+	pg_time_t	handoff_time;	/* wall-clock time of this record */
+} xl_pg_upgrade_handoff;
+
+#define SizeOfXLPgUpgradeHandoff	sizeof(xl_pg_upgrade_handoff)
+
+/*
+ * XLOG_UPGRADE_SLRU_DATA -- raw images of consecutive SLRU segment files.
+ * Each record batches segments first_seg..last_seg of one SLRU directory
+ * (slru_type; see UPGRADE_SLRU_* below); payload is this header followed by
+ * total_bytes of raw file data.  A directory's segments are split across as
+ * many records as needed to stay under the WAL record size limit.
+ * See pg_upgrade_redo().
+ */
+typedef struct xl_upgrade_slru_data
+{
+	uint8		slru_type;		/* which SLRU: 0=pg_xact, 1=mxoff, 2=mxmem */
+	int64		first_seg;		/* first segment file number in this record */
+	int64		last_seg;		/* last segment file number in this record */
+	uint32		total_bytes;	/* total bytes of raw SLRU data that follow */
+	/* followed by total_bytes of raw segment file data (consecutive segments) */
+} xl_upgrade_slru_data;
+
+#define SizeOfXLUpgradeSlruData		(offsetof(xl_upgrade_slru_data, total_bytes) + sizeof(uint32))
+
+/* slru_type values for xl_upgrade_slru_data */
+#define UPGRADE_SLRU_XACT		0
+#define UPGRADE_SLRU_MXOFF		1
+#define UPGRADE_SLRU_MXMEM		2
+
+/* directory paths corresponding to the slru_type values above */
+#define UPGRADE_SLRU_DIRS		{ "pg_xact", "pg_multixact/offsets", "pg_multixact/members" }
+
+/*
+ * XLOG_UPGRADE_RELFILE_DATA -- raw images of relation files.  One record
+ * batches many chunks up to the max WAL payload, as a sequence of entries each
+ * being an xl_upgrade_relfile_entry header followed by its nbytes of data:
+ *
+ *     [entry_0][data_0][entry_1][data_1] ... [entry_k][data_k]
+ *
+ * A segment larger than the payload cap is split into page-aligned chunks (see
+ * blockoff), possibly across several records.  See pg_upgrade_redo().
+ */
+typedef struct xl_upgrade_relfile_entry
+{
+	Oid			tablespace_oid; /* tablespace containing the file */
+	Oid			database_oid;	/* database OID (0 for shared relations) */
+	RelFileNumber relfilenumber;	/* relation file number */
+	uint8		forknum;		/* fork: 0=main, 1=FSM, 2=VM, 3=init */
+	uint32		segno;			/* 1GB segment number (0 = base segment) */
+	uint32		blockoff;		/* first block within the segment for this
+								 * chunk */
+	uint32		nbytes;			/* bytes of raw page data that follow */
+	/* followed by nbytes bytes of raw file data for this chunk */
+} xl_upgrade_relfile_entry;
+
+#define SizeOfXLUpgradeRelfileEntry		sizeof(xl_upgrade_relfile_entry)
+
+/*
+ * XLOG_UPGRADE_RELINK -- manifest of user relation files that pg_upgrade
+ * transferred verbatim (and the window therefore omits, keeping it
+ * schema-sized).  Each entry names one file by identity; no file data follows.
+ * One record batches many entries: [entry_0][entry_1] ... [entry_k].  Redo is a
+ * no-op on the primary and places each file from the standby's retained old
+ * datadir on a streaming standby.  See pg_upgrade_redo().
+ */
+typedef struct xl_upgrade_relink_entry
+{
+	Oid			tablespace_oid; /* tablespace containing the file */
+	Oid			database_oid;	/* database OID (0 for shared relations) */
+	RelFileNumber relfilenumber;	/* relation file number */
+	uint8		forknum;		/* fork: 0=main, 1=FSM, 2=VM, 3=init */
+	uint8		transfer_mode;	/* selects the placement primitive; see
+								 * UPGRADE_RELINK_MODE_* below and
+								 * relink_place_file() */
+	uint32		segno;			/* 1GB segment number (0 = base segment) */
+} xl_upgrade_relink_entry;
+
+/*
+ * transfer_mode values, mirroring pg_upgrade's transferMode (see
+ * src/bin/pg_upgrade/pg_upgrade.h); duplicated here because the record is read
+ * by the backend, which does not include pg_upgrade headers.
+ */
+#define UPGRADE_RELINK_MODE_CLONE			0
+#define UPGRADE_RELINK_MODE_COPY			1
+#define UPGRADE_RELINK_MODE_COPY_FILE_RANGE	2
+#define UPGRADE_RELINK_MODE_LINK			3
+#define UPGRADE_RELINK_MODE_SWAP			4
+
+#define SizeOfXLUpgradeRelinkEntry		sizeof(xl_upgrade_relink_entry)
+
+/*
+ * XLOG_UPGRADE_RAWFILE -- verbatim image of a non-relation file not reachable
+ * through the buffer manager (currently pg_filenode.map and PG_VERSION), so the
+ * cluster can be rebuilt from an empty data directory.  Payload is this header,
+ * then path_len bytes of PGDATA-relative path (no trailing NUL), then data_len
+ * bytes of contents.  See pg_upgrade_redo().
+ */
+typedef struct xl_upgrade_rawfile
+{
+	uint32		path_len;		/* length of the PGDATA-relative path */
+	uint32		data_len;		/* length of the file contents that follow */
+	/* followed by path_len bytes of path, then data_len bytes of contents */
+} xl_upgrade_rawfile;
+
+#define SizeOfXLUpgradeRawfile	(offsetof(xl_upgrade_rawfile, data_len) + sizeof(uint32))
+
+/*
+ * XLOG_UPGRADE_DIRTREE -- logged after-image of the new cluster's directory
+ * tree once pg_upgrade has finished, so recovery can rebuild the skeleton from
+ * WAL without a surviving on-disk skeleton and without running initdb.  Payload
+ * is this header followed by:
+ *   1. ndirs NUL-terminated PGDATA-relative directory paths (dir_bytes long),
+ *      emitted parent-before-child; then
+ *   2. nsymlinks symlink entries (sym_bytes long), each two NUL-terminated
+ *      strings: PGDATA-relative link path, then target.  These capture
+ *      user-tablespace symlinks (pg_tblspc/<spcoid> -> external location).
+ * See pg_upgrade_redo().
+ */
+typedef struct xl_upgrade_dirtree
+{
+	uint32		ndirs;			/* number of directory paths */
+	uint32		dir_bytes;		/* total bytes of directory-path data */
+	uint32		nsymlinks;		/* number of symlink entries */
+	uint32		sym_bytes;		/* total bytes of symlink-entry data */
+	/* followed by dir_bytes of dir paths, then sym_bytes of symlink entries */
+} xl_upgrade_dirtree;
+
+#define SizeOfXLUpgradeDirtree	(offsetof(xl_upgrade_dirtree, sym_bytes) + sizeof(uint32))
+
 
 /*
  * System status indicator.  Note this is stored in pg_control; if you change
@@ -103,6 +290,15 @@ typedef enum DBState
 	DB_IN_CRASH_RECOVERY,
 	DB_IN_ARCHIVE_RECOVERY,
 	DB_IN_PRODUCTION,
+
+	/*
+	 * A --wal-upgrade cluster replaying its upgrade window (between
+	 * XLOG_UPGRADE_START and _COMPLETE).  Informational only, so
+	 * pg_controldata shows "in pg_upgrade" for a half-reconstructed cluster;
+	 * it does not drive the recovery-mode decision.  Appended last to keep
+	 * on-disk values stable.
+	 */
+	DB_IN_UPGRADE,
 } DBState;
 
 /*
@@ -237,6 +433,24 @@ typedef struct ControlFileData
 	 */
 	bool		default_char_signedness;
 
+	/*
+	 * --wal-upgrade: true once the upgrade window has been replayed to
+	 * XLOG_UPGRADE_COMPLETE.  Durable "upgrade finalized" signal that lets
+	 * first-startup tell a fully-upgraded cluster from a crashed partial one.
+	 * See PerformWalUpgradeIfNeeded().
+	 */
+	bool		upgrade_finalized;
+
+	/*
+	 * --wal-upgrade: true once the burst server has begun emitting the window
+	 * (set just before XLOG_UPGRADE_START, cleared only at finalize).
+	 * Durable evidence that an upgrade started here, so a crashed partial
+	 * upgrade is detectable even when the START-bearing WAL did not survive.
+	 * started && !finalized => refuse to auto-serve.  See
+	 * PerformWalUpgradeIfNeeded().
+	 */
+	bool		upgrade_started;
+
 	/*
 	 * Random nonce, used in authentication requests that need to proceed
 	 * based on values that are cluster-unique, like a SASL exchange that
diff --git a/src/include/common/file_utils.h b/src/include/common/file_utils.h
index d6415424b6..81f89aa9c1 100644
--- a/src/include/common/file_utils.h
+++ b/src/include/common/file_utils.h
@@ -59,6 +59,23 @@ extern ssize_t pg_pwritev_with_retry(int fd,
 
 extern ssize_t pg_pwrite_zeros(int fd, size_t size, pgoff_t offset);
 
+/*
+ * Result of the reflink helpers below.  The caller decides how to report a
+ * failure (pg_fatal in the frontend, ereport in the backend), so these return a
+ * code rather than raising an error themselves.
+ */
+typedef enum PGReflinkResult
+{
+	PG_REFLINK_OK,				/* the clone/copy succeeded */
+	PG_REFLINK_UNSUPPORTED,		/* not compiled with support on this platform */
+	PG_REFLINK_ERROR,			/* a syscall failed; see *save_errno */
+}			PGReflinkResult;
+
+extern PGReflinkResult pg_clone_file(const char *src, const char *dst,
+									 int *save_errno);
+extern PGReflinkResult pg_copy_file_range_all(const char *src, const char *dst,
+											  int *save_errno);
+
 /* Filename components */
 #define PG_TEMP_FILES_DIR "pgsql_tmp"
 #define PG_TEMP_FILE_PREFIX "pgsql_tmp"
diff --git a/src/include/utils/guc.h b/src/include/utils/guc.h
index 8057d7870a..5a6de7c61f 100644
--- a/src/include/utils/guc.h
+++ b/src/include/utils/guc.h
@@ -345,6 +345,7 @@ extern PGDLLIMPORT bool optimize_bounded_sort;
 extern PGDLLIMPORT const struct config_enum_entry archive_mode_options[];
 extern PGDLLIMPORT const struct config_enum_entry dynamic_shared_memory_options[];
 extern PGDLLIMPORT const struct config_enum_entry io_method_options[];
+extern PGDLLIMPORT const struct config_enum_entry pg_upgrade_standby_transfer_mode_options[];
 extern PGDLLIMPORT const struct config_enum_entry recovery_target_action_options[];
 extern PGDLLIMPORT const struct config_enum_entry server_message_level_options[];
 extern PGDLLIMPORT const struct config_enum_entry wal_level_options[];
diff --git a/src/tools/pgindent/typedefs.list b/src/tools/pgindent/typedefs.list
index ffb413ab61..b554f6c798 100644
--- a/src/tools/pgindent/typedefs.list
+++ b/src/tools/pgindent/typedefs.list
@@ -1970,6 +1970,7 @@ PGP_S2K
 PGPing
 PGQueryClass
 PGRUsage
+PGReflinkResult
 PGSemaphore
 PGSemaphoreData
 PGShmemHeader
@@ -2369,11 +2370,14 @@ PgStat_TableStatus
 PgStat_TableXactStatus
 PgStat_WalCounters
 PgStat_WalStats
+PgUpgradeTransferMode
 PgXmlErrorContext
 PgXmlStrictness
 Pg_abi_values
 Pg_finfo_record
 Pg_magic_struct
+PhysicalSlotInfo
+PhysicalSlotInfoArr
 PipeProtoChunk
 PipeProtoHeader
 PlaceHolderInfo
@@ -2705,6 +2709,7 @@ ReturningClause
 ReturningExpr
 ReturningOption
 ReturningOptionKind
+RevertableOp
 RevmapContents
 RevokeRoleGrantAction
 RewriteMappingDataEntry
@@ -2941,6 +2946,7 @@ SlruErrorCause
 SlruOpts
 SlruPageStatus
 SlruScanCallback
+SlruSegInfo
 SlruSegState
 SlruShared
 SlruSharedData
@@ -3336,12 +3342,14 @@ UnresolvedTup
 UnresolvedTupData
 UpdateContext
 UpdateStmt
+UpgradeRelfileBatch
 UpgradeTask
 UpgradeTaskProcessCB
 UpgradeTaskReport
 UpgradeTaskSlot
 UpgradeTaskSlotState
 UpgradeTaskStep
+UpgradeWalReadPrivate
 UploadManifestCmd
 UpperRelationKind
 UserAuth
@@ -4521,6 +4529,8 @@ xl_multixact_create
 xl_multixact_truncate
 xl_overwrite_contrecord
 xl_parameter_change
+xl_pg_upgrade
+xl_pg_upgrade_handoff
 xl_relmap_update
 xl_replorigin_drop
 xl_replorigin_set
@@ -4534,6 +4544,11 @@ xl_standby_locks
 xl_tblspc_create_rec
 xl_tblspc_drop_rec
 xl_testcustomrmgrs_message
+xl_upgrade_dirtree
+xl_upgrade_rawfile
+xl_upgrade_relfile_entry
+xl_upgrade_relink_entry
+xl_upgrade_slru_data
 xl_xact_abort
 xl_xact_assignment
 xl_xact_commit
-- 
2.50.1 (Apple Git-155)

